#version 330 core

uniform mat4 u_projection;
uniform float u_explosionProgress;

// position is passed in world space
layout(triangles) in;
layout(triangle_strip, max_vertices=3) out;

flat in vec3 color[];
in vec3 normalWorldspace[];

flat out vec4 colorFace;

void main()
{
	// pass through original triangle
	vec4 faceNormal;
	faceNormal.xyz = (normalWorldspace[0]+normalWorldspace[1]+normalWorldspace[2]) / 3.0;
	faceNormal.w = 0.0;

	for(int i=0; i<3; i++)
	{
		gl_Position = u_projection * (gl_in[i].gl_Position + u_explosionProgress*faceNormal);
		colorFace.rgb = color[i];
		colorFace.a = 1.0-u_explosionProgress;
		colorFace.a *= colorFace.a; // lose alpha faster
		EmitVertex();
	}
	EndPrimitive();
}